
Helper = {}	-- O

-- N[W̕]ɓn߂̃A_v^`

function Helper.Not( eval )
	return function()
		return not Eval( eval )
	end
end

function Helper.And( ... )
	return function()
		for i,v in ipairs( arg ) do
			if not Eval( v ) then
				return false
			end
		end
		return true
	end
end

function Helper.Or( ... )
	return function()
		for i,v in ipairs( arg ) do
			if Eval( v ) then
				return true
			end
		end
		return false
	end
end

function Helper.Equals( a, b )
	return function()
		return Eval( a ) == Eval( b )
	end
end

function Helper.NotEquals( a, b )
	return function()
		return Eval( a ) ~= Eval( b )
	end
end

function Helper.Greater( a, b )
	return function()
		return Eval( a ) > Eval( b )
	end
end

function Helper.GreaterEquals( a, b )
	return function()
		return Eval( a ) >= Eval( b )
	end
end

function Helper.Less( a, b )
	return function()
		return Eval( a ) < Eval( b )
	end
end

function Helper.LessEquals( a, b )
	return function()
		return Eval( a ) <= Eval( b )
	end
end

-- N[W쐬ĕԂwp[

function Helper.Bind( func, ... )
	return function()
		-- e[uRs[ȂƓxڈȍ~ɐ]ȂA
		-- clone()gpƃc[\n܂deepcopyĂ܂߁A󂢃Rs[s
		local t = {}
		for i,v in ipairs( arg ) do
			t[i] = Eval( v )
		end
		return func( unpack( t ) )
	end
end

function Helper.If( eval, func, ... )	-- eval^ȂfuncsĕԂAfuncȂΐ^UlԂ
	return function()
		if Eval( eval ) then
			if func then
				return func( arg )
			else
				return true
			end
		end
		return false
	end
end


_if = Helper.If
_not = Helper.Not
_and = Helper.And
_or = Helper.Or
eq = Helper.Equals
ne = Helper.NotEquals
lt = Helper.Less
gt = Helper.Greater
le = Helper.LessEquals
ge = Helper.GreaterEquals
bind = Helper.Bind

function once()	-- xs
	local flag = false
	return function()
		local r = not flag
		flag = true
		return r
	end
end

function timer( interval )	-- intervalbo߂邲ƂtrueԂ
	local t = 0
	return function()
		local t2 = os.time()
		local r = os.difftime( t2, t ) >= interval
		if r then t = t2 end
		return r
	end
end

function tick_timer( interval )	-- interval~bo߂邲ƂtrueԂ
	local t = 0
	return function()
		local t2 = GetTick()
		local r = t2 - t >= interval
		if r then t = t2 end
		return r
	end
end

do
	local function Read( file )
		local t = 0 	-- l
		local chunk = loadfile( file )
		if chunk then
			t = chunk()
		end
		return t
	end
	
	local function Write( file, t )
		local fp = io.open( file, "w")
		if fp then
			fp:write("return "..t.."\n")
			fp:close()
		end
	end
	
	function stored_timer( interval, file )
		local t = Read( file )
		return function()
			local t2 = os.time()
			local r = os.difftime( t2, t ) >= interval
			if r then
				t = t2
				Write( file, t )
			end
			return r
		end
	end

	function stored_tick_timer( interval, file )
		local t = Read( file )
		return function()
			local t2 = GetTick()
			local r = t2 - t >= interval
	--		TraceAI("Timer: "..tostring(t).." "..tostring(t2))
			if r then
				t = t2
				Write( file, t )
			end
			return r
		end
	end
end

function timer_start( t )
	t() 	-- Jn
	return t
end

function ref( name )	-- name ̕ϐQƂ  _G ̕ϐQƂłȂ̂肩c
	return function( ... )
		if type( _G[ name ] ) == "function" then	-- bind ȂǂɊ֐n
			return _G[ name ]( unpack( arg ) )
		else
			return _G[ name ]
		end
	end
end

do
	local function func( v, percent )
		if not percent then percent = 100 end
		return function()
			return CalcPercentValue( GetV( v, MyID ), percent )
		end
	end
	
	function msp( percent )	-- MSPpercent̒lԂ
		return func( V_MAXSP, percent )
	end

	function mhp( percent )	-- MHPpercent̒lԂ
		return func( V_MAXHP, percent )
	end
	
	function sp( percent )	-- SPpercent̒lԂ
		return func( V_SP, percent )
	end

	function hp( percent )	-- HPpercent̒lԂ
		return func( V_HP, percent )
	end
end

function random( min, max )
	return function()
		return math.random( min, max )
	end
end
